PP = (window.PP || {});

PP.Sp = (function(){
	var User;
	
	return {
		init: function(user){
			User = user;
		},		
		is: function(callback){
			var url = 'http://fuwu.paipai.com/auth/spRegister.xhtml';
			$.ajax({
				url: url,
				cache: false,
				success: function(data){
					if(data.indexOf('topMenuCssChange(\'myfuwuMenu\')') != -1){
						callback(true);
					}else{
						callback(false);
					}
				},
				error: function(){}
			});
		},
		register: function(callback){
			var self = this,
				url = 'http://fuwu.paipai.com/auth/addSpRegInfo.xhtml';
				
			$.ajax({
				url: url,
				cache: false,
				data: {
					uin: User.uin,
					orgType: 0,
					name: User.name || User.nickName,
					phone: User.phone || User.mobile || '',
					email: User.email || User.uin + '@qq.com',
					address: User.address || ''
				},
				success: function(data){
					self.is(function(is){
						if(is){
							callback && callback(true);
						}else{
							alert('开发者注册错误！');
							callback(false);
						}
					});
				},
				error: function(){
					alert('开发者注册失败！');
				}
			});
		}	
	}
})();

PP.Api = (function() {
	var User = {},
		App = {
			appId: 168115,
			appOAuthID: '700039662',
			secretOAuthKey: 'SRBhE5hMlpKIHbHC'
		};

	return {
		getApp: function(){
			return App;
		},
		request: function(cid, arg, callback) {
			var arg = $.extend({
				timeStamp: new Date().getTime(),
				randomValue: parseInt(1000000 + Math.random() * 1e6),
				uin: User.uin,
				accessToken: App.accessToken,
				appOAuthID: App.appOAuthID,
				sellerUin: User.uin,
				charset: 'utf-8',
				pureData: 1,
				_: new Date().getTime()
			}, arg),
				sign = (function() {
					var data = [];
					$.each(arg, function(key, val) {
						data.push(key + '=' + val);
					});
					data.sort();

					var data2 = ['POST'];
					data2.push(encodeURIComponent('/' + cid.replace(/\./g, '/') + '.xhtml'));
					data2.push(encodeURIComponent(data.join('&')));
					return CryptoJS.enc.Base64.stringify(CryptoJS.HmacSHA1(data2.join('&'), (App.secretOAuthKey || secretOAuthKey) + '&'));
				})(),
				url = str_replace('http://api.paipai.com/{1}.xhtml', cid.replace(/\./g, '/'));

			$.ajax({
				url: url,
				type: 'post',
				dataType: 'json',
				data: $.extend(arg, {
					sign: sign
				}),
				success: function(data, jqXhr, textStatus) {
					callback(data);
				},
				error: function(jqXhr, textStatus) {
					var data;
					try {
						data = (new Function("return " + $.trim(jqXhr.responseText)))();
					} catch (e) {}
					callback(data);
				}
			});
		},
		authorise: function(cb) {
			var me = this;

			function authoriseSuccess(accessToken) { //授权成功回调
				var date = new Date();
				date.setMonth(date.getMonth() + 1);

				App.accessToken = accessToken;

				App.validate = toJson(date).split(/\s/)[0];
				Dialog.hide();
				cb(accessToken);
/*
				return;

				readValiDate(function(validate){
					App.validate = validate;

					Dialog.hide();
					cb(accessToken);
				});*/
			}

			function readValiDate(cb){//读取授权有效期
				$.ajax({
					url: 'http://fuwu.paipai.com/appstore/ui/my/app/applist.xhtml',
					cache: false,
					success: function(html){
						var Field = getFields({
							valiDate: /appdetail.xhtml\?appId=168115[\s\S]+?(\d\d\d\d-\d\d-\d\d)/
						}, html);

						if(Field.valiDate){
							cb(Field.valiDate);
						}else{
							this.error('失败');
						}
					},
					error: function(){
						Dialog.alert({
							title: '拍拍授权',
							content: '应用授权有效期读取' + (arguments[1]?'错误':arguments[0]) +'！',
							style: {
								width: 180
							}
						});
					}
				});
			}

			function authoriseFunc() { //授权
				$.ajax({
					url: 'http://fuwu.paipai.com/my/app/getAppTempToken.xhtml?appOAuthID=' + App.appOAuthID,
					cache: false,
					success: function(html) {
						var Field = getFields({
							accessToken: /<span class="code">(\w+)<\/span>该授权码仅用于\[\d+\]用户授权给/
						}, html);

						if (Field.accessToken) {
							authoriseSuccess(Field.accessToken);
						} else {
							this.error('失败');
						}
					},
					error: function() {
						Dialog.alert({
							title: '拍拍授权',
							content: '应用授权' + (arguments[1]?'错误':arguments[0]) + '！',
							style: {
								width: 180
							}
						});
					}
				});
			}

			function createApp(){
				$.ajax({
					url: 'http://fuwu.paipai.com/app/ui/my/create/submit.xhtml?' + $.param({
						g_tk: PP.User.getToken()
					}),
					type: 'post',
					data: {
						appName: '订单读取应用',
						userType: 0
					},
					success: function(html){
						var app = getFields({
							id: /><a href="\D+(\d+)">查看应用详情<\/a>/
						}, html);

						if(app.id || app.had){
							getAppDetail(app.id);
						}else{
							alert('应用创建错误！');
						}
					},
					error: function(){
						alert('应用创建失败！');
					}
				});
			}

			function getAppDetail(appId){
				$.ajax({
					url: 'http://fuwu.paipai.com/app/ui/my/list/detail.xhtml?appId=' + appId,
					success: function(html){
						App = getFields({
							appId: appId,
							appOAuthID: /appOAuthID：(\d+)/,
							secretOAuthKey: /appOAuthKey：(\w+)/
						}, html);

						if(!App.secretOAuthKey){
							Dialog.alert({
								title: '拍拍授权',
								content: '拍拍授权功能维护中！',
								style: {
									width: 220
								}
							});
							return;
						}

						authoriseFunc();
					},
					error: function(){
						alert('应用详情失败！');
					}
				});
			}


            function getAllPages(pages){
                var appId;
                var getID=function(page){
                    $.ajax({
                        url:'http://fuwu.paipai.com/app/ui/my/list/all.xhtml?pageIndex='+page,
                        cache:false,
                        success:function(html){
                            appId=getFields({
                                id: /<p class="name" id=".+?"><a href="\D+(\d+)">订单读取应用<\/a>/
                            }, html).id;
                            if(appId===false){
                                if(page<2){
                                    createApp();
                                }else{
                                    getID(--page);
                                }
                            }else{
                                getAppDetail(appId);
                            }
                        }
                    });
                }
                getID(pages);
            }


            function getApp(){
                var pages= 0,appId;
                $.ajax({
                    url:'http://fuwu.paipai.com/app/ui/my/list/all.xhtml',
                    cache:false,
                    success:function(html){
                        pages=html.match(/pageIndex=(\d+)" class="page-end">最末页/);
                        if(pages){
                            pages=pages[1];
                            getAllPages(pages);
                        }else{
                            appId = getFields({
                                id: /<p class="name" id=".+?"><a href="\D+(\d+)">订单读取应用<\/a>/
                            }, html).id;

                            if(!appId){
                                createApp();
                                return;
                            }else{
                                getAppDetail(appId);
                            }
                        }

                    },
                    error: function(){
                        alert('应用列表读取失败，请重试！');
                    }
                });
            }

			function orderApp(loginedUser) { //订购应用
				$.ajax({
					url: 'http://fuwu.paipai.com/my/app/orderApp.xhtml?agree=1&appId=' + App.appId,
					cache: false,
					success: function(html) {
						var error;
						if (html.match(/您已经订购了该应用|应用订购成功/)) {
							authoriseFunc(loginedUser);
						}else if (error = html.match(/msg=msg\+"([^"]+)"/)){
							this.orderError(error[1]);
						} else {
							this.orderError('未知错误');
						}
					},
					orderError: function(reason){
						Dialog.alert({
							title: '拍拍授权',
							content: reason?('应用订购失败：' + reason):'应用订购失败！',
							style: {
								width: 220
							}
						});
					},
					error: function() {
						PP.User.logout(function(){
							PP.User.login(function(loginedUser){
								orderApp(loginedUser);
							});
						});
					}
				});
			}

			PP.User.login(function(loginedUser) {
				Dialog.alert({
					title: '拍拍授权',
					content: '数据加载中…',
					style: {
						width: 200,
						height: 30
					},
					button: {
						'确 定': false
					}
				});

				User = loginedUser;

				PP.Sp.init(User);

				PP.Sp.is(function(flag){
					if(flag){
						getApp();
					}else{
						PP.Sp.register(function(){
							getApp();
						});
					}
				});

				//getApp();

				//orderApp(loginedUser);

				/*me.getMyOffline(loginedUser.uin, function(accessToken) {
					if (accessToken) {
						authoriseSuccess(loginedUser, accessToken);
					} else {
						orderApp(loginedUser);
					}
				});*/
			});

		},
		getMyOffline: function(qq, cb) {//读取服务器当前托管的拍拍账户信息
			var me = this;

			Pur5.get({
				action: 'getCookiesForUid',
				token: Pur5.getToken(),
				uid: Pur5.getUserId(),
				source: 'paipai',
				account: encodeURI(qq)
			}, function(Result, errMsg) {
				if (Result && Result.paipai && Result.paipai.uin == qq) {
					me.testAccessToken({
						uin: Result.paipai.uin,
						accessToken: Result.paipai.accessToken,
						appOAuthID: Result.paipai.appOAuthID,
						sellerUin: Result.paipai.uin
					}, function(success) {
						if (success) {
							cb(Result.paipai.accessToken);
						} else {
							cb(false);
						}
					});
				} else {
					cb(false);
				}
			});
		},		
		testAccessToken: function(arg, cb) {
			PP.Api.getOrders($.extend({
				dealState: 'DS_WAIT_BUYER_PAY',
				listItem: 1
			}, arg), function(Result) {
				if (Result && Result.pageIndex && Result.pageIndex == 1 && Result.errorCode === 0) {
					cb(true);
				} else {
					cb(false);
				}
			});
		},
		getOrders: function(arg, callback) { //根据标识取客户订单
			this.request('deal.sellerSearchDealList', $.extend({}, arg), callback);
		},
		deliver: function(dealCode, callback) { //订单发货
			this.request('deal.sellerConsignDealItem', {
				dealCode: dealCode,
				logisticsName: 'NO' //无需物流
			}, callback);
		},
		getDealDetail: function(arg, callback) {
			this.request('deal.getDealDetail', $.extend({
				listItem: 1
			}, arg), callback);
		},
		sellerCancelDeal: function(arg, callback) {
			this.request('deal.sellerCancelDeal', $.extend({
				closeReason: 2
			}, arg), callback);
		}
	}
})();