PP = (window.PP || {});
PP.User = (function() {
	var User,
		token = '',
		pt4_token;//for logout

	setInterval(function() {
		$.get('http://my.paipai.com/myppindex/buyer');
	}, 1000 * 60 * 10);

	function $time33(str) {
		for (var i = 0, len = str.length, hash = 5381; i < len; ++i) {
			hash += (hash << 5) + str.charAt(i).charCodeAt();
		};
		return hash & 0x7fffffff;
	};

	return {
		getUser: function() {
			return User;
		},
		getToken: function(){
			return token;
		},
		logout: function(cb) {
			$.ajax({
				url: 'http://ptlogin2.paipai.com/logout',
				data: {
					pt4_token: pt4_token,
					deep_logout: 1
				},
				complete: cb
			});
		},
		login: function(cb) {
			var self = this,
				redirectUrl = 'http://member.paipai.com/cgi-bin/ptlogin?loginfrom=18',
				loginAction = function() {
					var Size = {
						width: 490,
						height: 328
					};

					MiniBrowser.navigate({
						title: '拍拍登录',
						url: 'https://ssl.ui.ptlogin2.paipai.com/cgi-bin/login?' + $.param({
							appid: 17000101,
							daid: 126,
							pt_safe: 1,
							style: 13,
							target: 'self',
							link_target: 'blank',
							hide_title_bar: 1,
							hide_close_icon: 1,
							tmp: 201105241407,
							s_url: encodeURI(redirectUrl)
						}),
						//url: 'http://member.paipai.com/cgi-bin/login_entry',
						top: true,
						width: Size.width,
						height: Size.height,
						callback: function(obj, eventName) {
							if (eventName != 'documentComplete') {
								return;
							}

							(function() {
								if(obj.url != redirectUrl) return;

								var Field = getFields({
									loginedUin: /; uin=(?:o0+)?(\d+)/,
									pt4_token: /; pt4_token=(.+?);/,
									skey: /; skey=(.+?);/
								}, obj.cookie);

								if(!Field.loginedUin) return;

								token = $time33(Field.skey);
								pt4_token = Field.pt4_token;

								self.getUserInfo(function(User) {
									if (User) {
										MiniBrowser.hide();
										cb(User);
									}
								});
							})();
						}
					});
				};

			this.getUserInfo(function(User) {
				if (User) {
					Dialog.alert({
						title: '请确认',
						content: '当前登录拍拍是：[<strong style="color:#f00;">' + User.uin + '</strong>]，继续？',
						style: {
							width: 250,
							height: 30
						},
						button: {
							'确 定': function() {
								cb(User);
							},
							'切 换': function() {
								self.logout(loginAction);
							},
							'取 消': function() {}
						}
					});
				} else {
					self.logout(loginAction);
				}
			});
		},
		getUserInfo: function(callback) {
			var url = 'http://my.paipai.com/cgi-bin/c2cUser_view_userInfo';

			$.ajax({
				url: url,
				data: {
					g_tk: token
				},
				cache: false,
				success: function(data) {
					var Field = getFields({
						isLogined: /个人资料设置/,
						isSeller: /var bIsSeller="1";/,

						//todo:uin可能会取不到：提交到后台做错误处理
						uin: /<input type="hidden" id="userid" value="(\d+)" \/>/,
						email: /DoAlertEmail\('(.+?)',0,0\)/,
						name: /<input type="hidden"id="sName" name="sName" value="(.*?)"\/>/,
						nickName: /<th>昵称：<\/th>\s*<td>(\S+)/,
						address: /<input id="sAddress" name="sAddress" type="text" value="(.*?)"/,
						phone: /<input type="text" id="sPhone" name="sPhone" .+? value="(.*?)" >/,
						mobile: /DoAlertMobile\(1,'(.*?)', 0\)/
					}, data);

					if (!Field.isLogined || !Field.uin) {
						User = false;
					} else {
						User = Field;
					}

					callback && callback(User);
				},
				error: function() {
					callback && callback(false);
				}
			});
		}
	}
})();