﻿Tb = (window.Tb || {});
Tb.Api = (function() {
	var me,
		Data = {
			appkey: '12444247',
			shopId: '',
			session: '',
			nick: '',
			appsecret: '',
			group_name: 'dwd'
		},
		Arg = {},
		signOnClient = false,
		dataCache = {
			WAIT_SELLER_SEND_GOODS: {},
			WAIT_BUYER_PAY: {},
			RATE_UNSELLER: {},
			RATE_BUYER_UNSELLER: {}
		},
		timeDiffTaobao = 0,
		getApiError = function(result) {
			var errMsg = '';
			try {
				errMsg = '错误：' + result.error_response.msg;
				errMsg += result.error_response.sub_msg ? ('；子错误：' + result.error_response.sub_msg) : '';
			} catch (e) {}

			var callerArg = arguments.callee.caller.arguments;

			try {
				if (callerArg[1]) errMsg += 'response=' + callerArg[1];
			} catch (e) {}

			try {
				if (callerArg[2]) errMsg += ';textStatus=' + callerArg[2];
			} catch (e) {}

			return errMsg;
		},
		startPath = pur5.Cfg.startPath,
		popJsPath = startPath + 'scripts/taobao/tbaqpop.js';

	return {
		init: function(){
			me = this;

			return me;
		},
		setAppkey: function(Appkey) {
			Data.appkey = Appkey;
		},
		getAppkey: function() {
			return Data.appkey;
		},
		getArg: function() {
			return Arg;
		},
		getShop: function(cb) {
			me.req('taobao.shop.get', {
				nick: Data.nick,
				fields: 'sid, cid, nick, title, desc, bulletin, pic_path, created, modified, shop_score'
			}, function(result, errMsg) {
				cb(result?result.shop:null, errMsg);
			})
		},
		authorise: function(callback, actionString) {
			var self = this;

			function authoriseSuccess(Field) {
				$.extend(Arg, {
					refresh_time: new Date().getTime()
				}, Field);

				self.getTaobaoTime(function(time) {
					if (~callback.toString().indexOf('监控')) {
						self.refreshOffline(); //刷新托管时间
					}

					Data.nick = Arg.taobao_user_nick

					callback(Arg.taobao_user_nick);

					me.getShop(function(MyShop){
						if(!MyShop) return;

						if(Field.taobao_user_id == '333739601'){
							Data.group_name = 'test';
						}

						if(Field.taobao_user_id == '20622365'){//商吧
							Data.group_name = 'dwdjk';
						}

						if(Field.taobao_user_id == '22552328'){//当纽扣授权过来进行订单评价时
							Data.group_name = 'dbbjk';
						}

						me.req('taobao.tmc.user.permit', {}, function(result){//订阅消息
							if(!result) return;
							
							me.req('taobao.tmc.group.add', {
								group_name: Data.group_name,
								nicks: Arg.taobao_user_nick
							}, function(){})
						});
					});
				});
			}

			function authoriseFunc(arg) {
				Dialog.normalAlert('淘宝授权', '信息读取中……');
				var authorUrl = 'https://oauth.taobao.com/authorize',
					args = $.param({
						client_id: Data.appkey,
						response_type: 'token',
						scope: 'item, usergrade'
					}),
					authorPageUrl = authorUrl + '?' + args;

				function authorBox(AuthorBox) {
					var eventNames = [];

					MiniBrowser.navigate({
						title: '淘宝授权',
						url: AuthorBox.url,
						type: AuthorBox.params?'post':'get',
						params: AuthorBox.params,
						hide: true,
						top: true,
						width: AuthorBox.width,
						height: AuthorBox.height,
						callback: function(obj, eventName) {
							if (eventName == 'close') {
								Dialog.hide();
								return;
							}

							(function() {
								if (eventName != 'navigateComplete'){
									return;
								}

								var url = obj.url;

								if (/access_token=\w+/.test(url)) { //授权成功
									var Field = getFields({
										access_token: /access_token=(\w+)/,
										refresh_token: /refresh_token=(\w+)/,
										taobao_user_id: /taobao_user_id=(\d+)/,
										taobao_user_nick: /taobao_user_nick=([^&]+)/,
										re_expires_in: /re_expires_in=(\d+)/
									}, url);

									if (Field.access_token && Field.refresh_token && Field.taobao_user_nick) {
										Field.taobao_user_nick = decodeURI(Field.taobao_user_nick);

										Dialog.hide();
										authoriseSuccess(Field);
										MiniBrowser.hide({
											blank: true
										});
									}
								}
							})();

							(function() {
								if (!AuthorBox.params || eventName != 'documentComplete') return;
								var $body = $(obj.Win.document.body);
								$body.append('<style>html{overflow:hidden;}.aq_overlay_mask,.piao,.footer,.header,.aq_def_overlay_x{display:none;}.ad_def_overlay{position: static;}</style>');

								MiniBrowser.show(true, AuthorBox.width, AuthorBox.height);

								obj.Win.AQPop.addMethod({
									'cancel': function() {
										MiniBrowser.hide();
										Dialog.hide();
									}
								});
							})();
						}
					});
				}

				$.ajax({//读取授权参数
					url: authorPageUrl,
					success: function(html) {
						var that = this;
						(function() {
							var reg = /<form[\s\S]+?<\/form>/,
								form = reg.exec(html),
								Field;

							if (!form) {//未读到表格，直接打开用户自行处理
								that.error();
								return;
							}

							form = form[0];
							Field = $(form).serializeObject();
							Field.agreement = 'true';

							authorBox({//提交参数
								url: authorUrl,
								params: $.param(Field),
								width: 320,
								height: 280
							});
						})();
					},
					error: function(){
						authorBox({
							url: authorPageUrl
						});
					}
				});
			}

			Tb.User.login(function(loginedNick) {
				if(~loginedNick.indexOf(':')){
					Dialog.hide();
					Dialog.tip('不支持子账号授权', 1500);
					return;
				}
				authoriseFunc();
			});
		},
		getSign: function(method, stringForSign, callback) {
			$.ajax({
				url: Pur5.makeFullPath('offline/taobaoapisign.asp?' + method),
				type: 'post',
				dataType: 'text',
				cache: false,
				data: {
					a: 'getsign',
					v: stringForSign,
					token: Pur5.getToken()
				},
				success: function(result) {
					callback(result);
				},
				error: function(jqXhr, textStatus) {
					//alert(['签名错误', this.url, $.stringify(this.data)]);
					callback(false, jqXhr.responseText);
				}
			});
		},
		req: function(method, arg, callback){
			Tb.Api.request(method, arg, function(data, responseText, statusText){
				var result,
					text = '',
					errorText = '';
				try {
					result = data[method.replace('taobao.', '').replace(/\./g, '_') + '_response'];
				} catch (e) {}
				
				if(!result){			
					try{
						text = data.error_response.sub_msg;
					}catch(e){}

					if(!text){
						try{
							text = data.error_response.sub_code;
						}catch(e){
							text = responseText + statusText
						}					
					}
				}
				callback(result, text);
			});
		},		
		request: function(method, arg, callback) {
			var arg = $.extend({
				method: method,
				timestamp: toJson(new Date(new Date() - timeDiffTaobao)),
				format: 'json',
				app_key: Data.appkey,
				session: Arg.access_token,
				v: '2.0'
			}, arg),
				sign = (function() {
					var data = [];
					$.each(arg, function(key, val) {
						data.push('' + key + val);
					});

					data.sort();
					data.unshift(Data.appsecret);
					return $.md5(data.join('')).toUpperCase();
				})(),
				stringForSign = (function() {
					var data = [];
					$.each(arg, function(key, val) {
						data.push('' + key + val);
					});

					data.sort();
					return data.join('');
				}()),
				url = 'http://gw.api.taobao.com/router/rest',
				func = function(data) {
					$.ajax({
						url: url,
						type: 'post',
						timeout: 1000 * 30,
						dataType: 'json',
						data: data,
						success: function(data, textStatus, jqXhr) {
							callback(data);
						},
						error: function(jqXhr, textStatus) {
							var data;
							try {
								data = (new Function("return " + $.trim(jqXhr.responseText).replace(/[\r\n]/g, ' ')))();
							} catch (e) {}
							callback(data, jqXhr.responseText, textStatus);
						}
					});
				}

			if (signOnClient) {
				func($.extend(arg, {
					sign: sign
				}));
				return false;
			}

			if (method == 'taobao.trades.sold.get') {
				if (/^WAIT_BUYER_PAY|WAIT_SELLER_SEND_GOODS$/.test(arg.status) && dataCache[arg.status].data && new Date().getTime() - dataCache[arg.status].time < 1000 * 60 * 60 * 4) {
					func(dataCache[arg.status].data);
					return false;
				}
				if (/^RATE_UNSELLER|RATE_BUYER_UNSELLER$/.test(arg.rate_status) && dataCache[arg.rate_status].data && new Date().getTime() - dataCache[arg.rate_status].time < 1000 * 60 * 60 * 4) {
					func(dataCache[arg.rate_status].data);
					return false;
				}
			}

			this.getSign(method, stringForSign, function(sign, errMsg) {
				if (!/^[\dA-Z]{32}$/.test(sign)) {
					//alert('淘宝API参数签名错误:' + sign);
					//return false;
					callback(false, errMsg);
				} else {
					var data = $.extend(arg, {
						sign: sign
					});

					method == 'taobao.trades.sold.get' && ! function() {
						if (/^WAIT_BUYER_PAY|WAIT_SELLER_SEND_GOODS$/.test(arg.status)) {
							dataCache[arg.status].data = data,
							dataCache[arg.status].time = new Date().getTime()
						}
						if (/^RATE_UNSELLER|RATE_BUYER_UNSELLER$/.test(arg.rate_status)) {
							dataCache[arg.rate_status].data = data,
							dataCache[arg.rate_status].time = new Date().getTime()
						}

					}();
					func(data);
				}
			});
		},
		refreshSession: function(cb) {
			var self = this;

			$.ajax({ //读取刷新地址
				url: Pur5.makeFullPath('offline/TaobaoApiBack.asp'),
				type: 'get',
				dataType: 'json',
				data: {
					top_appkey: Data.appkey,
					top_parameters: $.param({
						refresh_token: Arg.refresh_token,
						visitor_nick: Arg.taobao_user_nick
					}),
					pur5_type: 1,
					top_session: Arg.access_token,
					dataType: 'json',
					t: new Date().getTime(),
					serverHttp: '',
					top_sign: ''
				},
				success: function(arr) {
					var sessionRefreshUrl = arr[7];
					if (!sessionRefreshUrl) {
						this.error();
						return;
					}

					$.ajax({ //开始刷新
						url: sessionRefreshUrl,
						type: 'post',
						dataType: 'json',
						success: function(result) {
							this.callbackFn(result);
						},
						error: function(jqXhr) {
							var result;
							try {
								result = (new Function("return " + $.trim(jqXhr.responseText)))();
							} catch (e) {}
							this.callbackFn(result);
						},
						callbackFn: function(result) {
							if (result && result.top_session && result.refresh_token) {
								dataCache = { //清除API请求参数缓存
									WAIT_SELLER_SEND_GOODS: {},
									WAIT_BUYER_PAY: {},
									RATE_UNSELLER: {},
									RATE_BUYER_UNSELLER: {}
								};

								$.extend(Arg, { //重置API参数
									refresh_time: new Date().getTime(),
									access_token: result.top_session,
									refresh_token: result.refresh_token
								});

								cb(true);
							} else {
								cb(false);
							}
						}
					});
				},
				error: function() {
					cb(false);
				}
			});
		},
		getNeedRateTids: function(callback) {
			var tids = [],
				ajaxResult = 0,
				resultFunc = function(result) {
					try {
						var trade = result.trades_sold_get_response.trades.trade;
						for (var i = 0; i < trade.length; i++) {
							if (trade[i].orders.order.length != 1) continue;
							if (!/^pur5.com[：\:]/.test(trade[i].orders.order[0].outer_iid)) continue;

							if ($.inArray(trade[i].tid, tids) == -1) {
								tids.push(trade[i].tid);
							}
						}
					} catch (e) {}

					ajaxResult++;
					if (ajaxResult === 2) {
						callback(tids);
					}
				};

			this.request('taobao.trades.sold.get', {
				start_created: toJson(new Date(new Date() - timeDiffTaobao - (1000 * 60 * 60 * 24 * 15))),
				status: 'TRADE_FINISHED',
				rate_status: 'RATE_BUYER_UNSELLER',
				fields: 'tid,orders'
			}, resultFunc);

			this.request('taobao.trades.sold.get', {
				start_created: toJson(new Date(new Date() - timeDiffTaobao - (1000 * 60 * 60 * 24 * 15))),
				status: 'TRADE_FINISHED',
				rate_status: 'RATE_UNSELLER',
				fields: 'tid,orders'
			}, resultFunc);
		},
		rate: function(tid, content, callback) {
			this.request('taobao.traderate.add', {
				tid: tid,
				result: 'good',
				role: 'seller',
				content: content
			}, function(result) {
				var rateResult;
				try {
					rateResult = (result.traderate_add_response.trade_rate.tid == tid);
				} catch (e) {}

				callback(rateResult, getApiError(result));
			});
		},
		getOrders: function(arg, callback) {
			this.request('taobao.trades.sold.get', {
				status: 'WAIT_SELLER_SEND_GOODS',
				use_has_next: 'true',
				page_size: 100,
				start_created: toJson(new Date(new Date() - timeDiffTaobao - (1000 * 60 * 60 * 24 * 5))),
				fields: 'seller_nick, buyer_nick, title, type, created, tid, seller_rate,buyer_flag, buyer_rate, status, payment, adjust_fee, post_fee, total_fee, pay_time, end_time, modified, consign_time, buyer_obtain_point_fee, point_fee, real_point_fee, received_payment, commission_fee, buyer_memo, seller_memo, alipay_no, buyer_message, pic_path, num_iid, num, price, buyer_alipay_no, receiver_name, receiver_state, receiver_city, receiver_district, receiver_address, receiver_zip, receiver_mobile, receiver_phone, buyer_email,seller_flag, seller_alipay_no, seller_mobile, seller_phone, seller_name, seller_email, available_confirm_fee, has_post_fee, timeout_action_time, snapshot_url, cod_fee, cod_status, shipping_type, trade_memo, is_3D,buyer_memo,buyer_email,orders'
			}, function(result) {
				var trade;
				try {
					trade = result.trades_sold_get_response.trades.trade;
				} catch (e) {}

				callback(trade, getApiError(result));
			});
		},
		getNoPayOrders: function(arg, callback) {
			this.request('taobao.trades.sold.get', {
				status: 'WAIT_BUYER_PAY',
				use_has_next: 'true',
				start_created: toJson(new Date(new Date() - timeDiffTaobao - (1000 * 60 * 60 * 24 * 5))),
				fields: 'seller_nick, buyer_nick, title, type, created, tid, seller_rate,buyer_flag, buyer_rate, status, payment, adjust_fee, post_fee, total_fee, pay_time, end_time, modified, consign_time, buyer_obtain_point_fee, point_fee, real_point_fee, received_payment, commission_fee, buyer_memo, seller_memo, alipay_no, buyer_message, pic_path, num_iid, num, price, buyer_alipay_no, receiver_name, receiver_state, receiver_city, receiver_district, receiver_address, receiver_zip, receiver_mobile, receiver_phone, buyer_email,seller_flag, seller_alipay_no, seller_mobile, seller_phone, seller_name, seller_email, available_confirm_fee, has_post_fee, timeout_action_time, snapshot_url, cod_fee, cod_status, shipping_type, trade_memo, is_3D,buyer_memo,buyer_email,orders'
			}, function(result) {
				var trade;
				try {
					trade = result.trades_sold_get_response.trades.trade;
				} catch (e) {}

				callback(trade, getApiError(result));
			});
		},
		closeOrder: function(tid, closeReason, callback) {
			this.request('taobao.trade.close', {
				tid: tid,
				close_reason: closeReason
			}, function(result) {
				var closeResult;
				try {
					closeResult = (result.trade_close_response.trade.tid == tid);
				} catch (e) {}

				callback(closeResult, getApiError(result));
			});
		},
		deliver: function(tid, callback) {
			this.request('taobao.logistics.dummy.send', {
				tid: tid
			}, function(result) {
				var sendResult;
				try {
					sendResult = result.logistics_dummy_send_response.shipping.is_success;
				} catch (e) {}

				try {
					if (result.error_response.sub_code == 'isv.logistics-dummy-service-error:B04') {
						sendResult = true;
					}
				} catch (e) {}

				callback(sendResult, getApiError(result));
			});
		},
		getDealDetail: function(tid, callback) {
			this.request('taobao.trade.fullinfo.get', {
				tid: tid,
				fields: 'seller_nick, buyer_nick, title, type, created, tid, seller_rate,buyer_flag, buyer_rate, status, payment, adjust_fee, post_fee, total_fee, pay_time, end_time, modified, consign_time, buyer_obtain_point_fee, point_fee, real_point_fee, received_payment, commission_fee, buyer_memo, seller_memo, alipay_no, buyer_message, pic_path, num_iid, num, price, buyer_alipay_no, receiver_name, receiver_state, receiver_city, receiver_district, receiver_address, receiver_zip, receiver_mobile, receiver_phone, buyer_email,seller_flag, seller_alipay_no, seller_mobile, seller_phone, seller_name, seller_email, available_confirm_fee, has_post_fee, timeout_action_time, snapshot_url, cod_fee, cod_status, shipping_type, trade_memo, is_3D,buyer_memo,buyer_email,orders'

			}, function(result) {
				var trade;
				try {
					trade = result.trade_fullinfo_get_response.trade;
					trade.order = trade.orders.order[0];
					delete trade.orders;
				} catch (e) {}

				callback(trade, getApiError(result));
			});
		},
		getUserInfo: function(callback) {
			this.request('taobao.user.get', {
				fields: 'user_id, nick, seller_credit'
			}, function(result) {
				var user;
				try {
					user = result.user_get_response.user;
				} catch (e) {}

				callback(user, getApiError(result));
			});
		},
		getSellercats: function(callback) {
			this.request('taobao.sellercats.list.get', {
				nick: Arg.taobao_user_nick
			}, function(result) {
				var cats;
				try {
					cats = result.sellercats_list_get_response.seller_cats.seller_cat;
				} catch (e) {}

				callback(cats, getApiError(result));
			});
		},
		getItemDetail: function(num_iid, callback) { //宝贝详情
			this.request('taobao.item.get', {
				num_iid: num_iid,
				fields: 'approve_status,num_iid,title,nick,type,cid,pic_url,num,props,valid_thru,list_time,price,has_discount,has_invoice,has_warranty,has_showcase,modified,delist_time,postage_id,seller_cids,outer_id,detail_url,props_name,'
			}, function(result) {
				var detail;
				try {
					detail = result.item_get_response.item;
				} catch (e) {}

				callback(detail, getApiError(result));
			});
		},
		getGoodsOnSale: function(arg, callback) { //售中宝贝
			this.request('taobao.items.onsale.get', $.extend({
				fields: 'approve_status,num_iid,title,nick,type,cid,pic_url,num,props,valid_thru,list_time,price,has_discount,has_invoice,has_warranty,has_showcase,modified,delist_time,postage_id,seller_cids,outer_id'
			}, arg), function(result) {
				var items,
					itemCount;
				try {
					items = result.items_onsale_get_response.items.item,
					itemCount = result.items_onsale_get_response.total_results;
				} catch (e) {}

				callback(items, itemCount, getApiError(result));
			});
		},
		getGoodsInStock: function(arg, callback) { //仓库宝贝
			this.request('taobao.items.inventory.get', $.extend({
				fields: 'approve_status,num_iid,title,nick,type,cid,pic_url,num,props,valid_thru, list_time,price,has_discount,has_invoice,has_warranty,has_showcase, modified,delist_time,postage_id,seller_cids,outer_id'
			}, arg), function(result) {
				var items,
					itemCount;
				try {
					items = result.items_inventory_get_response.items.item,
					itemCount = result.items_inventory_get_response.total_results;
				} catch (e) {}

				callback(items, itemCount, getApiError(result));
			});
		},
		listing: function(num_iid, num, callback) { //宝贝上架
			this.request('taobao.item.update.listing', {
				num_iid: num_iid,
				num: num
			}, function(result) {
				var result_num_iid;
				try {
					result_num_iid = result.item_update_listing_response.item.num_iid;
				} catch (e) {}

				callback(result_num_iid == num_iid, getApiError(result));
			});
		},
		delisting: function(num_iid, callback) { //宝贝下架
			this.request('taobao.item.update.delisting', {
				num_iid: num_iid
			}, function(result) {
				var result_num_iid;
				try {
					result_num_iid = result.item_update_delisting_response.item.num_iid;
				} catch (e) {}

				callback(result_num_iid == num_iid, getApiError(result));
			});
		},
		deleteItem: function(num_iid, callback) { //删除宝贝
			this.request('taobao.item.delete', {
				num_iid: num_iid
			}, function(result) {
				var result_num_iid;
				try {
					result_num_iid = result.item_delete_response.item.num_iid;
				} catch (e) {}

				callback(result_num_iid == num_iid, getApiError(result));
			});
		},
		itemJoinImg: function(arg, callback) {
			this.request('taobao.item.joint.img', $.extend({}, arg), function(result) {
				var url;
				try {
					url = result.item_joint_img_response.item_img.url;
				} catch (e) {}

				callback(url, getApiError(result));
			});
		},
		addGoods: function(arg, callback) { //添加宝贝
			this.request('taobao.item.add', $.extend({
				type: 'fixed',
				stuff_status: 'new'
			}, arg), function(result) {
				var item;
				try {
					item = result.item_add_response.item;
				} catch (e) {}

				callback(item, getApiError(result));
			});
		},
		updateSku: function(arg, callback) {
			this.request('taobao.item.sku.update', $.extend({}, arg), function(result) {
				var num_iid;
				try {
					num_iid = result.item_sku_update_response.sku.num_iid;
				} catch (e) {}

				callback(num_iid == arg.num_iid, getApiError(result));
			});
		},
		addCommend: function(arg, callback) { //橱窗推荐
			this.request('taobao.item.recommend.add', $.extend({}, arg), function(result) {
				var num_iid;
				try {
					num_iid = result.item_recommend_add_response.item.num_iid;
				} catch (e) {}

				callback(num_iid == arg.num_iid, getApiError(result));
			});
		},
		deleteCommend: function(arg, callback) { //取消橱窗推荐
			this.request('taobao.item.recommend.delete', $.extend({}, arg), function(result) {
				var num_iid;
				try {
					num_iid = result.item_recommend_delete_response.item.num_iid;
				} catch (e) {}

				callback(num_iid == arg.num_iid, getApiError(result));
			});
		},
		getTaobaoTime: function(callback) {
			this.request('taobao.time.get', {}, function(result) {
				var time;
				try {
					time = result.time_get_response.time;

					var times = time.match(/\d+/g).join(',');
					times[1] = times[1].replace(/^0/, '');
					times[1] = (times[1] - 1);

					timeDiffTaobao = new Function('return new Date()-new Date(' + times + ').getTime();')();
				} catch (e) {}

				callback(time, getApiError(result));
			});
		},
		refreshOffline: function() {
			$.ajax({ //托管
				url: pur5.Cfg.GBHOSTSOFT + 'offline/offline.asp?updateSessionOnMonitor',
				type: 'post',
				cache: false,
				data: {
					token: pur5.Cfg.token,
					lv: 't1',
					updateReason: 'monitor',
					source: 'taobao',
					ww: encodeURIComponent(Arg.taobao_user_nick),
					wwId: Arg.taobao_user_id,
					cookie: encodeURIComponent($.stringify({
						session: Arg.access_token,
						refresh_token: Arg.refresh_token,
						refresh_time: new Date().getTime()
					}))
				}
			});
		}
	}
})().init();