﻿Tb = (window.Tb || {});
Tb.User = (function() {
	var me,
		loginStatusCheckUrl = 'http://mai.taobao.com/json/home/seller_menu_data.htm',
		loginedReg = /,"login":true,/,
		token = '',
		showLoginDialog = false,
		lastLoginTbUser = '../log/lastLoginTbUser.pur5',
		shopId,
		Logined = {};

	return {
		appRoot: '',
		nick: '',
		session: '',
		LoginTip: (function() {
			var callback,
				$loginTip = $('<div>本功能需要获取您的店铺信息 点击<a class="login-btn" href="#">登录店铺</a></div>')
					.css({
						'white-space': 'nowrap',
						position: 'absolute',
						top: 0,
						left: 0,
						padding: '4px 8px',
						color: '#fff',
						"line-height": "17px",
						'z-index': 999,
						'background-color': '#333',
						display: 'none'
					})
					.appendTo(document.body)
					.find('a').css({
						'color': '#fff',
						'text-decoration': 'underline'
					}).end();

			return {
				show: function(Login) {
					var	Pos = Menu.getIframePosition(),
						windowWidth = $(window).width(),
						animateHeight = 20;

					$loginTip.css({
						left: windowWidth - $loginTip.outerWidth() - 5,
						top: Pos.top + animateHeight,
						opacity: 0
					}).off().show().animate({
						opacity: 0.85,
						top: Pos.top
					})
						.on('click', '.login-btn', function() {
							Login.manually = true;
							me.login(Login);
						});
				},
				firstShow: function(Login) {
					var Pos = Menu.getIframePosition(),
						windowWidth = $(window).width(),
						windowHeight = $(window).height(),
						animateHeight = 20;

					$loginTip.css({
						left: windowWidth - $loginTip.outerWidth() - 5,
						top: Pos.top,
						opacity: 0.85,
						display: 'block'
					})

					var DialogSize = arguments.callee.DialogSize,
						myPos = {
							left: $loginTip.position().left,
							top: Pos.top,
							width: $loginTip.width(),
							height: $loginTip.height()
						};

					$loginTip.css({
						left: (windowWidth - DialogSize.width) / 2,
						top: (windowHeight - DialogSize.height) / 2,
						width: DialogSize.width - 16,
						height: DialogSize.height - 8,
						opacity: 0.85
					}).off().stop().animate({
						left: myPos.left,
						top: myPos.top,
						width: myPos.width,
						height: myPos.height
					}, 500)
						.on('click', '.author-btn, .login-btn', function() {
							Login.manually = true;
							me.login(Login);
						});
				},
				hide: function() {
					$loginTip.hide();
				}
			}
		})(),
		init: function() {
			me = this;

			/*Dwd.loginSuccess(function() {
				Menu.change(function() {
					me.LoginTip.hide();
				});
			});*/

			setInterval(function() { //刷用户session，保持连接
				$.post(loginStatusCheckUrl);
			}, 1000 * 60 * 10);

			return this;
		},
		getToken: function() {
			return token;
		},
		logout: function(cb) { //登出
			$.ajax({
				url: 'http://login.taobao.com/member/logout.jhtml',
				type: 'get',
				complete: cb
			});
		},
		cancelAuthorise: function(CancelAuthoriseObject) {
			$.ajax({
				url: 'http://container.api.taobao.com/container/authManager',
				cache: false,
				data: {
					action: 'cancel',
					appId: CancelAuthoriseObject.appId,
					_tb_token_: token
				},
				success: function(Result) {
					var state = false;
					try {
						state = Result.Result.state == 1;
					} catch (e) {}

					CancelAuthoriseObject.callback({
						state: state
					});
				},
				complete: function() {
					CancelAuthoriseObject.callback({
						state: false
					});
				}
			});
		},
		login: function(cb, nick, add) { //登录
			var args = arguments,
				loginUrl = 'https://login.taobao.com/member/login.jhtml?' + $.param({
					sub: 'true',
					style: 'mini_top',
					from: 'mini_top',
					from_encoding: 'utf-8'
				}),
				loginAction = function() {
					var Size ={
						width: 310,
						height: 298
					};

					Dialog.normalAlert('淘宝登录', '数据读取中……');
					MiniBrowser.navigate({
						title: '淘宝登录',
						url: loginUrl,
						top: true,
						width: Size.width,
						height: Size.height,
						callback: function(obj, eventName){
							if(eventName == 'close'){
								Dialog.hide();
							}

							if(eventName == 'beforeNavigate' && /(https?:\/\/(i|login)\.taobao\.com|quicklogin=true)/.test(obj.url)){
								MiniBrowser.hide();
							}
							if(eventName != 'documentComplete'){
								return;
							}

							var Field = getFields({
								subNumber: /sn=([^;$]+)/,
								nk: /_nk_=([^;$]+)/,
								token: /_tb_token_=([^;$]+)/
							}, obj.cookie);

							if(Field.subNumber){
								Field.subNumber = decodeURIComponent(Field.subNumber);
							}

							if(Field.nk || Field.subNumber){//已经登录用户
								me.getLoginedNick(function(userNick){
									MiniBrowser.hide({
										blank: true//清空页面
									});

									setTimeout(function(){
										cb && cb(userNick);
									}, 400);
								});
								return;
							}

							(function() { //异常登录，直接显示异常页面给用户自行处理
								if (~obj.url.indexOf('login_unusual.htm')) {
									MiniBrowser.show(true, 320, 270);
								}
							})();

							(function(){
								if(!~obj.url.indexOf('login.taobao.com')){
									return;
								}

								var $body = $(obj.Win.document.body);

								$body.find('#J_LoginBox').css({
									width: 250,
									padding: 10
								});

								$body.find('.bd').css({
									padding: 0
								});

								 $body = null;
								 MiniBrowser.show(true);
							})();

							(function() { //登录成功
								return;
								var nickName,
									userId;

								if(!/(http:\/\/i\.taobao\.com|quicklogin=true)/.test(obj.url)){
									return;
								}

								try {
									nickName = obj.cookie.match(/_nk_=([^;$]+)/)[1];
									nickName = unescape(decodeURI(nickName).replace(/\\/g, '%'));

									userId = /userid=(\d+)/.exec(obj.content)[1];
								} catch (e) {alert('读取淘宝用户名失败： '+ e.description);
									return;
								}

								if (userId && nickName) {
									Dialog.hide();
									MiniBrowser.hide({
										blank: true
									});

									setTimeout(function(){
										Logined[userId] = nickName;
										cb && cb(nickName);
										me.setToken();
									}, 400);
								}
							})();
						}
					});		
				},
				checker = function() {
					me.getLoginedNick(function(loginedNick) {
						if ((nick && nick == loginedNick) || loginedNick) {
							Dialog.alert({
								title: '请确认',
								content: '<div style="padding:5px;">当前登录旺旺是：[<strong style="color:#f00;">' + loginedNick + '</strong>]，继续？</div>',
								style: {
									width: 250
								},
								button: {
									'确 定': function() {
										cb(loginedNick);
									},
									'切 换': function() {
										me.logout(function() {
											loginAction();
										});
									},
									'取 消': function() {}
								}
							});
						} else {
							loginAction();
						}
					});
				};

			showLoginDialog = false;
			if (add) {
				loginAction();
			} else {
				checker();
			}
		},
		isLogin: function(cb) { //是否登录了淘宝
			$.ajax({
				url: loginStatusCheckUrl,
				success: function(html) {
					if (loginedReg.test(html)) {
						me.getLoginedNick(cb);
					} else {
						cb(false);
					}
				},
				error: function() {
					cb(false);
				}
			});
		},
		getLoginedNick: function(cb) { //取登录用户的昵称
			$.ajax({
				url: 'http://mai.taobao.com/seller_admin.htm',
				cache: false,
				success: function(html){
					var Field = getFields({
						userNick: /class="user-nick">(.+?)<\/a>/,//子账号
						token: /&_tb_token_=(.+?)">/,//子账号
						userId: /&userid=(\d+)/
					}, html);

					if(Field.userNick && Field.token && Field.userId){
						Logined[Field.userId] = Field.userNick;
						token = Field.token;
						cb(Field.userNick);
						return;
					}

					if(!Field.userId){
						cb(false);
						return;
					}

					$.ajax({
						url: 'http://i.taobao.com/user/baseInfoSet.htm',
						cache: false,
						success: function(html){
							var Field = getFields({
								userNick: />亲爱的<b>(.+?)<\/b>/,
								token: /<input name='_tb_token_' type='hidden' value='(.+?)'>/,
								userId: /&userid=(\d+)/
							}, html);

							if(Field.userNick && Field.token && Field.userId){
								Logined[Field.userId] = Field.userNick;
								token = Field.token;
								cb(Field.userNick);
							}else{
								cb(false);
							}
						}
					});
				},
				error: function(){
					cb(false);
				}
			});
		},
		/*setToken: function() {
			$.ajax({
				url: 'http://container.api.taobao.com/container/authManager?t=' + Number(new Date()),
				success: function(html) {
					token = getFields({
						token: /<input name="_tb_token_" type="hidden" value="(\w+)"/
					}, html).token;
				}
			});
		},*/
		getShopId: function(cb){
			if(shopId){
				cb(shopId);
				return;
			}

			$.ajax({
				url: 'http://siteadmin.taobao.com/design.htm',
				success: function(text){
					try{
						shopId = text.match(/shopId=(\d+)/)[1];
					}catch(e){}

					if(shopId){
						cb(shopId);
					}					
				}
			});
		}
	}
})().init();