var FileTransfer = (function(){
	var Ax,
		callback,
		div = document.createElement('div'),
		timeout = 1000 * 10,
		timer,
		me;

	div.style.display = '';
	div.innerHTML = '<script language="javascript" event="ondownprogress(total, bytes)"\
						for="FileTransferAx">FileTransfer.event.downloadProgress(total, bytes);<\/script>\
					\
					<script language="javascript" event="ondownloadend()"\
						for="FileTransferAx">FileTransfer.event.downloadEnd();<\/script>\
					\
					<script language="javascript" event="ondownloaderror(errCode)"\
						for="FileTransferAx">FileTransfer.event.downloadError(errCode);<\/script>\
					\
					<script language="javascript" event="uploadend(srcPath, desPath)"\
						for="FileTransferAx">FileTransfer.event.uploadEnd(srcPath, desPath);<\/script>\
					\
					<script language="javascript" event="onuploaderror(errorCode)"\
						for="FileTransferAx">FileTransfer.event.uploadError(errorCode);<\/script>\
					\
					<object id="FileTransferAx" classid="CLSID:0607442D-F5E5-484B-BBD4-BCB3B38FEF6B"  style="position: absolute; z-index:1;width:0;height:0"></object>';

	document.body.appendChild(div);
	Ax = document.getElementById('FileTransferAx');

	return {
		init: function(){
			me = this;
			return this;
		},
		event: {
			downloadProgress: function(total, bytes){
				this.callback('downloadProgress', {
					total: total,
					bytes: bytes
				});
			},
			downloadEnd: function(){
				this.callback('downloadEnd');
			},
			downloadError: function(errCode){
				this.callback('downloadError', {
					timeout: errCode != 0,
					errCode: errCode
				});
			},
			uploadEnd: function(srcPath, desPath){
				this.callback('uploadEnd', {
					srcPath: srcPath,
					desPath: desPath
				});
			},
			uploadError: function(errorCode){
				this.callback('uploadError', {
					errorCode: errorCode,
					errMsg: Ax.ErrMsg
				});
			},
			callback: function(eventName, Arg){
				if(eventName != 'downloadProgress'){
					clearTimeout(timer);
				}

				callback && callback(eventName, Arg);
			}
		},
		action: {
			stopDownload: function(arg){
				Ax.TerminateDownload(arg.url);
			},
			stopUpload: function(arg){
				Ax.TerminateUpload(arg.url);
			}
		},
		decompress: function(rarFilePath, desPath){
			Ax.Decompress(rarFilePath, desPath);
		},
		uploadTbPic: function(arg){
			callback = arg.callback;

			timer = setTimeout(function(){
				me.action.stopUpload({
					url: arg.filePath
				});
				me.event.callback('uploadError', {
					timeout: true,
					errCode: ''
				});
			}, arg.timeout || timeout);			

			Ax.Upload(arg.filePath);
		},
		download: function(arg){
			callback = arg.callback;

			Ax.RecvTimeout = arg.timeout || timeout;
			Ax.Download(arg.url, arg.savePath);
		}
	}
})().init();